4 ### expected to be run as root
8 #################### global vars
10 DB_CONF_FILE=@DBDIR@/conf.db
11 DB_SCHEMA=@pkgdatadir@/vswitch.ovsschema
12 DB_LOG=@LOGDIR@/ovs-db.log
14 DB_SOCKET=$RUN_DIR/db.sock
16 SWITCH_LOG=@LOGDIR@/ovs-switch.log
18 #################### helper functions
20 function kill_pltap_ovs () {
21 killall pltap-ovs 2>/dev/null || :
31 err_msg="$COMMAND $SUBCOMMAND $(echo $params | perl -pe 's/\S+/<$&>/g')"
33 [[ -z "$@" ]] && error "$err_msg"
34 pname=$(echo -n $p|perl -pe 's/\W/_/g')
35 eval $pname="$1"; shift
37 [[ -n "$@" ]] && error "$err_msg"
40 function is_switch_running {
41 ovs-appctl --target=ovs-vswitchd version >& /dev/null
44 function is_db_running {
45 ovs-appctl --target=ovsdb-server version >& /dev/null
50 echo $(ip addr show to "$IP/32" | perl -ne '/^\s*\d+:\s*([\w-]+):/ && print $1')
53 function wait_server () {
58 expire=$(($(date +%s) + $timeout))
60 ## wait for it to be up - xxx todo - could use a timeout of some kind
61 while [ ! -f "$pid_file" ]; do
62 echo "Waiting for $server_name to start... $(($expire - $(date +%s)))s left" >&2
64 [ $(date +%s) -ge $expire ] && return 1
69 function wait_device () {
70 local tapname=$1; shift
71 local timeout=$1; shift
73 local expire=$(($(date +%s) + $timeout))
75 while ! ip link show up | egrep -q "^[0-9]+: +$tapname:"; do
76 echo "Waiting for $tapname to come UP...$(($expire - $(date +%s)))s left" >&2
78 [ $(date +%s) -ge $expire ] && return 1
83 ######################################## startup
84 function start_db () {
88 conf_dir=$(dirname $DB_CONF_FILE)
89 [ -d $conf_dir ] || mkdir -p $conf_dir
90 [ -f $DB_CONF_FILE ] || ovsdb-tool create $DB_CONF_FILE $DB_SCHEMA
93 [ -d $RUN_DIR ] || mkdir -p $RUN_DIR
96 [ -f $DB_CONF_FILE ] || { echo "Could not initialize $DB_CONF_FILE - exiting" ; exit 1 ; }
97 [ -d $RUN_DIR ] || { echo "Could not initialize $RUN_DIR - exiting" ; exit 1 ; }
100 if [ ! -f "$RUN_DIR/ovsdb-server.pid" ]; then
101 ovsdb-server $DB_CONF_FILE \
102 --remote=punix:$DB_SOCKET \
103 --remote=db:Open_vSwitch,Open_vSwitch,manager_options \
104 --private-key=db:Open_vSwitch,SSL,private_key \
105 --certificate=db:Open_vSwitch,SSL,certificate \
106 --bootstrap-ca-cert=db:Open_vSwitch,SSL,ca_cert \
109 --detach >& /dev/null
111 echo 'ovsdb-server appears to be running already, *not* starting'
113 wait_server $RUN_DIR/ovsdb-server.pid ovsdb-server 30
116 function start_switch () {
119 # ensure ovsdb-server is running
120 is_db_running || { echo "ovsdb-server not running" >&2 ; exit 1 ; }
122 if [ ! -f "$RUN_DIR/ovs-vswitchd.pid" ] ; then
125 --log-file=$SWITCH_LOG \
127 unix:$DB_SOCKET >& /dev/null
129 echo 'ovs-vswitchd appears to be running already, *not* starting'
131 wait_server $RUN_DIR/ovs-vswitchd.pid ovs-vswitchd 30
134 function stop_db () {
135 ovs-appctl --target=ovsdb-server exit || :
138 function stop_switch () {
139 ovs-appctl --target=ovs-vswitchd exit || :
144 [ -n "$pids" ] && ps $pids
157 #################### create functions
158 function create_bridge () {
160 get_params "bridge IP/PREFIX" "$1" "$2"
164 PREFIX=${IP_PREFIX#*/}
167 if ! is_switch_running; then
168 # we can create the bridge even if ovs-vswitchd is not running,
169 # but we need a running ovsdb-server
170 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
176 ovs-vsctl --db=unix:$DB_SOCKET $W -- --may-exist add-br "$bridge" \
177 -- set bridge "$bridge" datapath_type=planetlab \
178 -- set interface "$bridge" options:local_ip="$IP" option:local_netmask="$PREFIX" \
181 # check that the bridge has actually been created
183 local tap=$(ovs-appctl netdev-pltap/get-tapname "$bridge")
188 function create_port () {
190 get_params "bridge port" "$@"
193 if ! is_switch_running; then
194 # we can create the port even if ovs-vswitchd is not running,
195 # but we need a running ovsdb-server
196 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
201 ovs-vsctl --db=unix:$DB_SOCKET $W -- --may-exist add-port "$bridge" "$port" \
202 -- set interface "$port" type=tunnel
205 function get_local_endpoint () {
207 get_params "local_port" "$@"
209 is_switch_running || { echo "ovs-vswitchd not running" >&2; exit 1; }
212 ovs-appctl --target=ovs-vswitchd netdev-tunnel/get-port "$local_port"
215 function set_remote_endpoint () {
217 get_params "local_port remote_ip remote_UDP_port" "$@"
220 if ! is_switch_running; then
221 # we can store the info even if ovs-vswitchd is not running,
222 # but we need a running ovsdb-server
223 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
228 ovs-vsctl --db=unix:$DB_SOCKET $W set interface $local_port \
229 options:remote_ip=$remote_ip \
230 options:remote_port=$remote_UDP_port
233 function set_controller () {
235 get_params "bridge_name controller" "$@"
237 # ensure ovs-vswitchd is running
238 is_switch_running || { echo "ovs-vswitchd not running" >&2 ; exit 1 ; }
241 ovs-vsctl --db=unix:$DB_SOCKET set-controller "$bridge_name" "$controller"
244 function del_controller () {
246 get_params "bridge_name" "$@"
248 # ensure ovs-vswitchd is running
249 is_switch_running || { echo "ovs-vswitchd not running" >&2 ; exit 1 ; }
252 ovs-vsctl --db=unix:$DB_SOCKET del-controller "$bridge_name"
255 #################### del functions
256 function del_bridge () {
258 get_params "bridge_name" "$@"
261 if ! is_switch_running; then
262 # we can delete the bridge even if ovs-vswitchd is not running,
263 # but we need a running ovsdb-server
264 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
268 ovs-vsctl --db=unix:$DB_SOCKET $W -- --if-exists del-br $bridge_name
271 function del_port () {
273 get_params "port" "$@"
276 if ! is_switch_running; then
277 # we can delete the port even if ovs-vswitchd is not running,
278 # but we need a running ovsdb-server
279 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
283 ovs-vsctl --db=unix:$DB_SOCKET $W -- --if-exists del-port "$port"
290 is_db_running || { echo "ovsdb-server not running" >&2; exit 1; }
292 ovs-vsctl --db=unix:$DB_SOCKET show
295 function get_local_ip () {
297 get_params "bridge" "$@"
300 ovs-vsctl --db=unix:$DB_SOCKET br-exists "$bridge" || return
301 local ip=$(ovs-vsctl get interface "$bridge" options:local_ip)
302 local netmask=$(ovs-vsctl get interface "$bridge" options:local_netmask)
303 eval echo $ip/$netmask
306 function get_local_links () {
308 get_params "bridge" "$@"
311 ovs-vsctl --db=unix:$DB_SOCKET br-exists "$bridge" || return
312 ovs-vsctl --db=unix:$DB_SOCKET list-ifaces "$bridge"
315 function get_mac () {
317 get_params "bridge" "$@"
320 local tap=$(ovs-appctl netdev-pltap/get-tapname "$bridge")
321 ifconfig "$tap" | awk '/HWaddr/ { print $5 }'
324 ### for demos - connect to an ndnmap deployment to visualize links bandwidth
325 # this expects 3 arguments
326 # an interface name, L<id1>-<id2> based on your ids in conf.mk
327 # the hostname for a ndnmap deployment
328 # a linkid, this is the id that this link has in your ndnmap scenario (hard-coded in some json file)
329 # this one-shot function writes the current statistics onto the ndnmap site
330 # it needs to be called regularly so that ndnmap can do the bw computations
331 # would make sense for the caller to redirect stderr onto some relevant location
332 function gmap_probe_once () {
336 rx_bytes=$(ovs-appctl netdev-tunnel/get-rx-bytes $iface)
337 tx_bytes=$(ovs-appctl netdev-tunnel/get-tx-bytes $iface)
338 rx_bits=$(($rx_bytes*8))
339 tx_bits=$(($tx_bytes*8))
340 now=$(date +%s).$(date +%N)
341 trigger=http://${hostname}/bw/${linkid}/${now}/${rx_bits}/${tx_bits}
342 # curl -s -L $trigger | grep -q "Got it" || echo Missed event with $trigger
344 curl -s -L $trigger >& /dev/null
347 ### the front end, manages pid and so on
348 function gmap_probe () {
353 [ -z "$looptime" ] && looptime=1
354 pid_file=/var/run/openvswitch/gmap-$iface.pid
355 if [ -f $pid_file ] ; then
357 [ -n "$pid" ] && kill $pid >& /dev/null
360 # close std fds so that ssh invokations can return
364 gmap_probe_once $iface $hostname $linkid
367 # this is the pid for the background process
372 SUPPORTED_SUBCOMMANDS="start stop status
373 start_db stop_db start_switch stop_switch
374 create_bridge create_port del_bridge del_port
375 show get_local_endpoint set_remote_endpoint
376 set_controller del_controller gmap_probe
377 get_local_ip get_local_links get_mac"
380 message="Usage: $COMMAND <subcommand> ...
381 Supported subcommands are (dash or underscore is the same):
382 $SUPPORTED_SUBCOMMANDS"
383 [[ -z "$@" ]] && error "$message"
386 # support dashes instead of underscores
387 SUBCOMMAND=$(echo $SUBCOMMAND | sed -e s,-,_,g)
389 for supported in $SUPPORTED_SUBCOMMANDS; do [ "$SUBCOMMAND" = "$supported" ] && found=yes; done
391 [ -z "$found" ] && error $message